#!/bin/bash

# Compute mercartor tile-coordinates
# Last change: 2008-05-18 (Frank Baettermann)

if [ $# -ne 3 ]; then
    echo "Usage: $0 LATITUDE LOGITUDE ZOOM"
    exit 1
fi

if [ -z "`which bc 2> /dev/null`" ]; then
    echo "ERROR: Could not find bc!"
    exit 1
fi

LATITUDE=$1
LOGITUDE=$2
ZOOM=$3

# total width and height in tiles
MAP_SIZE=$((2**$ZOOM))
echo "map_size=$MAP_SIZE"

# logitude -> x
echo "tile_x=`echo "($LOGITUDE + 180) * $MAP_SIZE / 360" | bc`"

# latitude -> y
echo "tile_y=`echo "\
    scale=10; \
    phi=$LATITUDE; \
    mapsize=$MAP_SIZE; \
    pi=3.1415926535; \
    phi_rad=phi*2*pi/360; \
    mercator=l((1+s(phi_rad))/(1-s(phi_rad)))/(2); \
    tile=(1-mercator/pi)*(mapsize/2); \
    scale=0; tile/1" \
    | bc -l`"
